#!/bin/bash

MLX_CARD=$1
MLX_PORT=$2
GPUID=$3
SIZE=65536

AWK=/bin/awk
KILLALL=/usr/bin/killall
IBV_BIN=ibv_rdma_bw
GPU_BIN=gpu_rdma_bw

PATH=/usr/bin/nvidia-healthmon-tests/:./bin/:$NVH_TEST_DIR:$PATH

# IBV->GPU
$GPU_BIN -d $MLX_CARD -i $MLX_PORT -g $GPUID -s $SIZE -q &> /dev/null&
sleep 2
$IBV_BIN -d $MLX_CARD -i $MLX_PORT -s $SIZE -q  localhost 2>&1 | $AWK -F: '/Bandwidth average/{print $3+0}'

# GPU->IBV
$IBV_BIN -d $MLX_CARD -i $MLX_PORT -s $SIZE -q &> /dev/null&
sleep 2
$GPU_BIN -d $MLX_CARD -i $MLX_PORT -s $SIZE -g $GPUID -q  localhost 2>&1 | $AWK -F: '/Bandwidth average/{print $3+0}'

$KILLALL -9 $IBV_BIN &> /dev/null
$KILLALL -9 $GPU_BIN &> /dev/null
